	// verilator_coverage annotation
	// generated by verigenSV.pl on Fri Jun  4 13:21:36 2021
	// input file: mesq.cfg
	
	// compiler directives
	/* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	/* verilator lint_off UNUSED */
	/* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	
	module MESQ (
 000100		input logic clk,
%000004		input logic res_n,
%000002		input logic opc_vld,
 000029		input logic [OPC_WIDTH-1:0] opc,
 000030		input logic rd_q0,
 000030		input logic rd_q1,
 000045		output logic [OPC_WIDTH-1:0] data_q0, 
%000002		output logic empty_q0, 
%000003		output logic full_q0, 
 000080		output logic [OPC_WIDTH-1:0] data_q1, 
%000002		output logic empty_q1, 
 000025		output logic full_q1 );
	
	  //
	 // parameter constants 
	//---------------------------
	parameter int OPC_WIDTH = 5 ;
	parameter int QUEUE_SIZE = 8 ;
	parameter logic [OPC_WIDTH-1:0] ZERO_DATA = {OPC_WIDTH{1'b0}};
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [0:0] {
		Q0 = 1'b0,
		Q1 = 1'b1
	} states_t;
	
	
	// internal state variables
 000016	states_t STATE, NEXT_STATE;
 000017	verilator_coverage: (next point on previous line)

	
	  //
	 // memory instantiations 
	//---------------------------
	QUEUE #( OPC_WIDTH, QUEUE_SIZE ) Q0_QUEUE(
		.clk(clk), .res_n(res_n), 
		.wr(Q0_QUEUE_wr), .wr_data(Q0_QUEUE_wr_data[OPC_WIDTH-1:0]), 
		.rd(Q0_QUEUE_rd), .rd_data(Q0_QUEUE_rd_data[OPC_WIDTH-1:0]), 
		.empty(empty_q0), .full(full_q0) );
	
	QUEUE #( OPC_WIDTH, QUEUE_SIZE ) Q1_QUEUE(
		.clk(clk), .res_n(res_n), 
		.wr(Q1_QUEUE_wr), .wr_data(Q1_QUEUE_wr_data[OPC_WIDTH-1:0]), 
		.rd(Q1_QUEUE_rd), .rd_data(Q1_QUEUE_rd_data[OPC_WIDTH-1:0]), 
		.empty(empty_q1), .full(full_q1) );
	
	   //
	  // implicit continuous assignments 
	 // (derived from <expressions> section) 
	//----------------------------------
%000006	uwire IDLE; assign IDLE = ~opc_vld & res_n;
%000002	uwire WRITE_QUEUE; assign WRITE_QUEUE = opc_vld & res_n;
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001	  STATE = Q0;
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	end
	
	  //
	 // state transfer
	//---------------------------
 000100	always_ff @( posedge clk ) begin
 000088	  if( res_n )
%000006	  verilator_coverage: (next point on previous line)

 000044	    STATE <= NEXT_STATE;
	  else
%000006	    STATE <= Q0;
	
	  // condition for $finish (Verilator)
%000002	  if( rd_q0==1'b1 && rd_q1==1'b1 && res_n==1'b0 ) begin
 000049	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
%000002	cover property ( @(posedge clk) rd_q0==1'b1 && rd_q1==1'b1 && res_n==1'b0 );
	
 000272	always_comb begin
	
	    //
	   // pre-case (default) assignments 
	  //----------------------------------
 000136	  data_q0=POP_Q0_QUEUE(rd_q0);
 000136	  data_q1=POP_Q1_QUEUE(rd_q1);
	
 000136	  unique case ( STATE )
 000094	  Q0 : begin
 000030		if ( IDLE ) begin
 000032		verilator_coverage: (next point on previous line)

 000015		  NEXT_STATE = Q0;
		end
 000032		if ( WRITE_QUEUE ) begin
 000031		verilator_coverage: (next point on previous line)

 000016		  NEXT_STATE = Q1;
 000016		  PUSH_Q0_QUEUE(1'b1,opc);
 000016		  NOP_Q1_QUEUE();
		end
	  end // Q0
 000178	  Q1 : begin
 000144		if ( IDLE ) begin
 000017		verilator_coverage: (next point on previous line)

 000072		  NEXT_STATE = Q1;
		end
 000030		if ( WRITE_QUEUE ) begin
 000074		verilator_coverage: (next point on previous line)

 000015		  NEXT_STATE = Q0;
 000015		  PUSH_Q1_QUEUE(1'b1,opc);
 000015		  NOP_Q0_QUEUE();
		end
	  end // Q1
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
 000030	logic Q0_QUEUE_rd;
 000047	logic [OPC_WIDTH-1:0] Q0_QUEUE_rd_data;
	
 000272	function automatic [OPC_WIDTH-1:0] POP_Q0_QUEUE( read );
 000136	   Q0_QUEUE_rd = read;
 000136	   return Q0_QUEUE_rd_data;
	endfunction
	
 000016	logic Q0_QUEUE_wr;
 000045	logic [OPC_WIDTH-1:0] Q0_QUEUE_wr_data;
	
 000032	function automatic void PUSH_Q0_QUEUE( write, [OPC_WIDTH-1:0] write_data);
 000016	   Q0_QUEUE_wr = write;
 000016	   Q0_QUEUE_wr_data = write_data;
	endfunction
	
 000030	function automatic void NOP_Q0_QUEUE();
 000015	   Q0_QUEUE_rd = 0;
 000015	   Q0_QUEUE_wr = 0;
 000015	   Q0_QUEUE_wr_data = '0;
	endfunction
	
 000030	logic Q1_QUEUE_rd;
 000080	logic [OPC_WIDTH-1:0] Q1_QUEUE_rd_data;
	
 000272	function automatic [OPC_WIDTH-1:0] POP_Q1_QUEUE( read );
 000136	   Q1_QUEUE_rd = read;
 000136	   return Q1_QUEUE_rd_data;
	endfunction
	
 000015	logic Q1_QUEUE_wr;
 000056	logic [OPC_WIDTH-1:0] Q1_QUEUE_wr_data;
	
 000030	function automatic void PUSH_Q1_QUEUE( write, [OPC_WIDTH-1:0] write_data);
 000015	   Q1_QUEUE_wr = write;
 000015	   Q1_QUEUE_wr_data = write_data;
	endfunction
	
 000032	function automatic void NOP_Q1_QUEUE();
 000016	   Q1_QUEUE_rd = 0;
 000016	   Q1_QUEUE_wr = 0;
 000016	   Q1_QUEUE_wr_data = '0;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module QUEUE ( clk, res_n, wr, wr_data, rd, rd_data, empty, full );
	
	parameter DATA_WIDTH = 32;
	parameter NUM_ENTRIES = 16;
	parameter ADDR_WIDTH = $clog2(NUM_ENTRIES);
	
 000200	input  logic clk, res_n, rd, wr;
%000008	verilator_coverage: (next point on previous line)

 000060	verilator_coverage: (next point on previous line)

 000031	verilator_coverage: (next point on previous line)

 000101	input  logic [DATA_WIDTH-1:0] wr_data;
 000127	output logic [DATA_WIDTH-1:0] rd_data;
%000004	output logic empty, full;
 000028	verilator_coverage: (next point on previous line)

	    
	parameter ZERO_ADDR = {ADDR_WIDTH{1'b0}};
	parameter ZERO_DATA = {DATA_WIDTH{1'b0}};
	
%000093	logic [DATA_WIDTH-1:0] MEMORY [NUM_ENTRIES-1:0];
 000039	logic [ADDR_WIDTH-1:0] HEAD; 
 000051	logic [ADDR_WIDTH-1:0] TAIL; 
	
	integer i;
	
%000004	initial begin
%000002	    for ( i = 0; i < NUM_ENTRIES; i = i + 1 ) begin
 000032	    verilator_coverage: (next point on previous line)

 000016	        MEMORY[ i ] = ZERO_DATA;
	    end
%000002	    HEAD = ZERO_ADDR;
%000002	    TAIL = ZERO_ADDR;
	end
	
	// IN-CYCLE READ ACCESS
	assign rd_data = ( rd && res_n ) ? MEMORY[HEAD] : ZERO_DATA;
	assign empty = (HEAD==TAIL);
	assign full = (HEAD==(TAIL+1'b1));
	
 000200	always_ff @ ( posedge clk ) begin
 000176	    if( res_n ) begin
 000012	    verilator_coverage: (next point on previous line)

 000038	        if( rd & !empty ) HEAD <= (HEAD + 1'b1); // READ ACCESS
 000069	        verilator_coverage: (next point on previous line)

 000050	        if( wr & !full ) begin // WRITE ACCESS
 000063	        verilator_coverage: (next point on previous line)

 000025		    MEMORY[TAIL] <= wr_data;
 000025	            TAIL <= (TAIL + 1'b1);
	        end
 000012	    end else begin
 000012		HEAD <= ZERO_ADDR;
 000012	        TAIL <= ZERO_ADDR;
 000012	        MEMORY[ZERO_ADDR] <= ZERO_DATA;
	    end
	end
	
	endmodule
	
