// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See VMESQ.h for the primary calling header

#include "VMESQ.h"
#include "VMESQ__Syms.h"

//==========

void VMESQ::eval_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+++++TOP Evaluate VMESQ::eval\n"); );
    VMESQ__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
#ifdef VL_DEBUG
    // Debug assertions
    _eval_debug_assertions();
#endif  // VL_DEBUG
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        VL_DEBUG_IF(VL_DBG_MSGF("+ Clock loop\n"););
        vlSymsp->__Vm_activity = true;
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("MESQ.sv", 12, "",
                "Verilated model didn't converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

void VMESQ::eval_end_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+eval_end_step VMESQ::eval_end_step\n"); );
#ifdef VM_TRACE
    VMESQ__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Tracing
    if (VL_UNLIKELY(vlSymsp->__Vm_dumping)) _traceDump();
#endif  // VM_TRACE
}

void VMESQ::_eval_initial_loop(VMESQ__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        _eval_settle(vlSymsp);
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("MESQ.sv", 12, "",
                "Verilated model didn't DC converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

VL_INLINE_OPT void VMESQ::_combo__TOP__1(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_combo__TOP__1\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    if (((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd) ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd)) {
        ++(vlSymsp->__Vcoverage[48]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd = vlTOPp->MESQ__DOT__Q0_QUEUE_rd;
    }
    if (((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd) ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd)) {
        ++(vlSymsp->__Vcoverage[63]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd = vlTOPp->MESQ__DOT__Q1_QUEUE_rd;
    }
    if (((IData)(vlTOPp->clk) ^ vlTOPp->MESQ__DOT____Vtogcov__clk)) {
        ++(vlSymsp->__Vcoverage[0]);
        vlTOPp->MESQ__DOT____Vtogcov__clk = vlTOPp->clk;
    }
    if (((IData)(vlTOPp->res_n) ^ vlTOPp->MESQ__DOT____Vtogcov__res_n)) {
        ++(vlSymsp->__Vcoverage[1]);
        vlTOPp->MESQ__DOT____Vtogcov__res_n = vlTOPp->res_n;
    }
    if (((IData)(vlTOPp->opc_vld) ^ vlTOPp->MESQ__DOT____Vtogcov__opc_vld)) {
        ++(vlSymsp->__Vcoverage[2]);
        vlTOPp->MESQ__DOT____Vtogcov__opc_vld = vlTOPp->opc_vld;
    }
    if (((IData)(vlTOPp->rd_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__rd_q0)) {
        ++(vlSymsp->__Vcoverage[8]);
        vlTOPp->MESQ__DOT____Vtogcov__rd_q0 = vlTOPp->rd_q0;
    }
    if (((IData)(vlTOPp->rd_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__rd_q1)) {
        ++(vlSymsp->__Vcoverage[9]);
        vlTOPp->MESQ__DOT____Vtogcov__rd_q1 = vlTOPp->rd_q1;
    }
    if ((1U & ((IData)(vlTOPp->opc) ^ vlTOPp->MESQ__DOT____Vtogcov__opc))) {
        ++(vlSymsp->__Vcoverage[3]);
        vlTOPp->MESQ__DOT____Vtogcov__opc = ((0x1eU 
                                              & (IData)(vlTOPp->MESQ__DOT____Vtogcov__opc)) 
                                             | (1U 
                                                & (IData)(vlTOPp->opc)));
    }
    if ((2U & ((IData)(vlTOPp->opc) ^ vlTOPp->MESQ__DOT____Vtogcov__opc))) {
        ++(vlSymsp->__Vcoverage[4]);
        vlTOPp->MESQ__DOT____Vtogcov__opc = ((0x1dU 
                                              & (IData)(vlTOPp->MESQ__DOT____Vtogcov__opc)) 
                                             | (2U 
                                                & (IData)(vlTOPp->opc)));
    }
    if ((4U & ((IData)(vlTOPp->opc) ^ vlTOPp->MESQ__DOT____Vtogcov__opc))) {
        ++(vlSymsp->__Vcoverage[5]);
        vlTOPp->MESQ__DOT____Vtogcov__opc = ((0x1bU 
                                              & (IData)(vlTOPp->MESQ__DOT____Vtogcov__opc)) 
                                             | (4U 
                                                & (IData)(vlTOPp->opc)));
    }
    if ((8U & ((IData)(vlTOPp->opc) ^ vlTOPp->MESQ__DOT____Vtogcov__opc))) {
        ++(vlSymsp->__Vcoverage[6]);
        vlTOPp->MESQ__DOT____Vtogcov__opc = ((0x17U 
                                              & (IData)(vlTOPp->MESQ__DOT____Vtogcov__opc)) 
                                             | (8U 
                                                & (IData)(vlTOPp->opc)));
    }
    if ((0x10U & ((IData)(vlTOPp->opc) ^ vlTOPp->MESQ__DOT____Vtogcov__opc))) {
        ++(vlSymsp->__Vcoverage[7]);
        vlTOPp->MESQ__DOT____Vtogcov__opc = ((0xfU 
                                              & (IData)(vlTOPp->MESQ__DOT____Vtogcov__opc)) 
                                             | (0x10U 
                                                & (IData)(vlTOPp->opc)));
    }
    vlTOPp->MESQ__DOT__IDLE = ((~ (IData)(vlTOPp->opc_vld)) 
                               & (IData)(vlTOPp->res_n));
    vlTOPp->MESQ__DOT__WRITE_QUEUE = ((IData)(vlTOPp->opc_vld) 
                                      & (IData)(vlTOPp->res_n));
    if (((IData)(vlTOPp->MESQ__DOT__IDLE) ^ vlTOPp->MESQ__DOT____Vtogcov__IDLE)) {
        ++(vlSymsp->__Vcoverage[26]);
        vlTOPp->MESQ__DOT____Vtogcov__IDLE = vlTOPp->MESQ__DOT__IDLE;
    }
    if (((IData)(vlTOPp->MESQ__DOT__WRITE_QUEUE) ^ vlTOPp->MESQ__DOT____Vtogcov__WRITE_QUEUE)) {
        ++(vlSymsp->__Vcoverage[27]);
        vlTOPp->MESQ__DOT____Vtogcov__WRITE_QUEUE = vlTOPp->MESQ__DOT__WRITE_QUEUE;
    }
}

VL_INLINE_OPT void VMESQ::_sequent__TOP__4(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_sequent__TOP__4\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    CData/*2:0*/ __Vdlyvdim0__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0;
    CData/*4:0*/ __Vdlyvval__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v1;
    CData/*2:0*/ __Vdlyvdim0__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0;
    CData/*4:0*/ __Vdlyvval__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v1;
    // Body
    if ((((IData)(vlTOPp->rd_q0) & (IData)(vlTOPp->rd_q1)) 
         & (~ (IData)(vlTOPp->res_n)))) {
        ++(vlSymsp->__Vcoverage[36]);
    }
    __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0 = 0U;
    __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v1 = 0U;
    __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0 = 0U;
    __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v1 = 0U;
    ++(vlSymsp->__Vcoverage[35]);
    if (VL_UNLIKELY((((IData)(vlTOPp->rd_q0) & (IData)(vlTOPp->rd_q1)) 
                     & (~ (IData)(vlTOPp->res_n))))) {
        VL_WRITEF("*-* All Finished *-*\n");
        ++(vlSymsp->__Vcoverage[33]);
        VL_FINISH_MT("MESQ.sv", 96, "");
    } else {
        ++(vlSymsp->__Vcoverage[34]);
    }
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[31]);
        vlTOPp->MESQ__DOT__STATE = vlTOPp->MESQ__DOT__NEXT_STATE;
    } else {
        ++(vlSymsp->__Vcoverage[32]);
        vlTOPp->MESQ__DOT__STATE = 0U;
    }
    ++(vlSymsp->__Vcoverage[187]);
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[185]);
        if (((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd) 
             & (~ (IData)(vlTOPp->empty_q1)))) {
            ++(vlSymsp->__Vcoverage[181]);
            vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD 
                = (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD)));
        } else {
            ++(vlSymsp->__Vcoverage[182]);
        }
        if (((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr) 
             & (~ (IData)(vlTOPp->full_q1)))) {
            ++(vlSymsp->__Vcoverage[183]);
            __Vdlyvval__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0 
                = vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data;
            __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0 = 1U;
            __Vdlyvdim0__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0 
                = vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL;
            vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL 
                = (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL)));
        } else {
            ++(vlSymsp->__Vcoverage[184]);
        }
    } else {
        ++(vlSymsp->__Vcoverage[186]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD = 0U;
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL = 0U;
        __Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v1 = 1U;
    }
    ++(vlSymsp->__Vcoverage[132]);
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[130]);
        if (((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd) 
             & (~ (IData)(vlTOPp->empty_q0)))) {
            ++(vlSymsp->__Vcoverage[126]);
            vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD 
                = (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD)));
        } else {
            ++(vlSymsp->__Vcoverage[127]);
        }
        if (((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr) 
             & (~ (IData)(vlTOPp->full_q0)))) {
            ++(vlSymsp->__Vcoverage[128]);
            __Vdlyvval__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0 
                = vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data;
            __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0 = 1U;
            __Vdlyvdim0__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0 
                = vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL;
            vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL 
                = (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL)));
        } else {
            ++(vlSymsp->__Vcoverage[129]);
        }
    } else {
        ++(vlSymsp->__Vcoverage[131]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD = 0U;
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL = 0U;
        __Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v1 = 1U;
    }
    if (__Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0) {
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[__Vdlyvdim0__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0] 
            = __Vdlyvval__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v0;
    }
    if (__Vdlyvset__MESQ__DOT__Q1_QUEUE__DOT__MEMORY__v1) {
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[0U] = 0U;
    }
    if (__Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0) {
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[__Vdlyvdim0__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0] 
            = __Vdlyvval__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v0;
    }
    if (__Vdlyvset__MESQ__DOT__Q0_QUEUE__DOT__MEMORY__v1) {
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[0U] = 0U;
    }
    if (((IData)(vlTOPp->MESQ__DOT__STATE) ^ vlTOPp->MESQ__DOT____Vtogcov__STATE)) {
        ++(vlSymsp->__Vcoverage[24]);
        vlTOPp->MESQ__DOT____Vtogcov__STATE = vlTOPp->MESQ__DOT__STATE;
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[133]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[134]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[135]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[136]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [0U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [0U]))) {
        ++(vlSymsp->__Vcoverage[137]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[138]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[139]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[140]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[141]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [1U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [1U]))) {
        ++(vlSymsp->__Vcoverage[142]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[143]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[144]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[145]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[146]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [2U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [2U]))) {
        ++(vlSymsp->__Vcoverage[147]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[148]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[149]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[150]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[151]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [3U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [3U]))) {
        ++(vlSymsp->__Vcoverage[152]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[153]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[154]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[155]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[156]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [4U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [4U]))) {
        ++(vlSymsp->__Vcoverage[157]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[158]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[159]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[160]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[161]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [5U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [5U]))) {
        ++(vlSymsp->__Vcoverage[162]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[163]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[164]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[165]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[166]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [6U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [6U]))) {
        ++(vlSymsp->__Vcoverage[167]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[168]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (1U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[169]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (2U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[170]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (4U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[171]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (8U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                  [7U] ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                  [7U]))) {
        ++(vlSymsp->__Vcoverage[172]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (0x10U & vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[176]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL 
            = ((6U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[177]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL 
            = ((5U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[178]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL 
            = ((3U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__TAIL)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL)));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[173]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD 
            = ((6U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[174]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD 
            = ((5U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[175]);
        vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD 
            = ((3U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT____Vtogcov__HEAD)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD)));
    }
    vlTOPp->empty_q1 = ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD) 
                        == (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL));
    vlTOPp->full_q1 = ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD) 
                       == (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL))));
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[78]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[79]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[80]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [0U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[81]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [0U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [0U]))) {
        ++(vlSymsp->__Vcoverage[82]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[0U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [0U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [0U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[83]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[84]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[85]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [1U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[86]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [1U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [1U]))) {
        ++(vlSymsp->__Vcoverage[87]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[1U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [1U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [1U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[88]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[89]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[90]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [2U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[91]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [2U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [2U]))) {
        ++(vlSymsp->__Vcoverage[92]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[2U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [2U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [2U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[93]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[94]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[95]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [3U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[96]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [3U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [3U]))) {
        ++(vlSymsp->__Vcoverage[97]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[3U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [3U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [3U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[98]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[99]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[100]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [4U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[101]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [4U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [4U]))) {
        ++(vlSymsp->__Vcoverage[102]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[4U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [4U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [4U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[103]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[104]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[105]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [5U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[106]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [5U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [5U]))) {
        ++(vlSymsp->__Vcoverage[107]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[5U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [5U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [5U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[108]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[109]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[110]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [6U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[111]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [6U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [6U]))) {
        ++(vlSymsp->__Vcoverage[112]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[6U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [6U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [6U]));
    }
    if ((1U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[113]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1eU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (1U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((2U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[114]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1dU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (2U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((4U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[115]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x1bU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (4U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((8U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
               [7U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[116]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0x17U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (8U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((0x10U & (vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                  [7U] ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                  [7U]))) {
        ++(vlSymsp->__Vcoverage[117]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY[7U] 
            = ((0xfU & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__MEMORY
                [7U]) | (0x10U & vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                         [7U]));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[121]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL 
            = ((6U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[122]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL 
            = ((5U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL))) {
        ++(vlSymsp->__Vcoverage[123]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL 
            = ((3U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__TAIL)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL)));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[118]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD 
            = ((6U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[119]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD 
            = ((5U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD) 
               ^ vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[120]);
        vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD 
            = ((3U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT____Vtogcov__HEAD)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD)));
    }
    vlTOPp->empty_q0 = ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD) 
                        == (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL));
    vlTOPp->full_q0 = ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD) 
                       == (7U & ((IData)(1U) + (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL))));
    if (((IData)(vlTOPp->empty_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__empty_q1)) {
        ++(vlSymsp->__Vcoverage[22]);
        vlTOPp->MESQ__DOT____Vtogcov__empty_q1 = vlTOPp->empty_q1;
    }
    if (((IData)(vlTOPp->full_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__full_q1)) {
        ++(vlSymsp->__Vcoverage[23]);
        vlTOPp->MESQ__DOT____Vtogcov__full_q1 = vlTOPp->full_q1;
    }
    if (((IData)(vlTOPp->empty_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__empty_q0)) {
        ++(vlSymsp->__Vcoverage[15]);
        vlTOPp->MESQ__DOT____Vtogcov__empty_q0 = vlTOPp->empty_q0;
    }
    if (((IData)(vlTOPp->full_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__full_q0)) {
        ++(vlSymsp->__Vcoverage[16]);
        vlTOPp->MESQ__DOT____Vtogcov__full_q0 = vlTOPp->full_q0;
    }
}

VL_INLINE_OPT void VMESQ::_combo__TOP__6(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_combo__TOP__6\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data = (((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd) 
                                            & (IData)(vlTOPp->res_n))
                                            ? vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY
                                           [vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD]
                                            : 0U);
    vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data = (((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd) 
                                            & (IData)(vlTOPp->res_n))
                                            ? vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY
                                           [vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD]
                                            : 0U);
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[64]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data 
            = ((0x1eU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[65]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data 
            = ((0x1dU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[66]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data 
            = ((0x1bU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[67]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data 
            = ((0x17U & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data)) 
               | (8U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data) 
                  ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[68]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data 
            = ((0xfU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_rd_data)) 
               | (0x10U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data)));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[49]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data 
            = ((0x1eU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[50]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data 
            = ((0x1dU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[51]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data 
            = ((0x1bU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[52]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data 
            = ((0x17U & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data)) 
               | (8U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data) 
                  ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data))) {
        ++(vlSymsp->__Vcoverage[53]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data 
            = ((0xfU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_rd_data)) 
               | (0x10U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data)));
    }
    vlTOPp->__Vfunc_MESQ__DOT__POP_Q0_QUEUE__0__read 
        = vlTOPp->rd_q0;
    vlTOPp->__Vfunc_MESQ__DOT__POP_Q0_QUEUE__0__Vfuncout 
        = vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data;
    ++(vlSymsp->__Vcoverage[54]);
    vlTOPp->__Vfunc_MESQ__DOT__POP_Q1_QUEUE__1__Vfuncout 
        = vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data;
    ++(vlSymsp->__Vcoverage[69]);
    ++(vlSymsp->__Vcoverage[47]);
    vlTOPp->MESQ__DOT__Q0_QUEUE_rd = vlTOPp->__Vfunc_MESQ__DOT__POP_Q0_QUEUE__0__read;
    vlTOPp->data_q0 = vlTOPp->__Vfunc_MESQ__DOT__POP_Q0_QUEUE__0__Vfuncout;
    vlTOPp->data_q1 = vlTOPp->__Vfunc_MESQ__DOT__POP_Q1_QUEUE__1__Vfuncout;
    if (VL_UNLIKELY((1U & (~ VL_ONEHOT_I((((IData)(vlTOPp->MESQ__DOT__STATE) 
                                           << 1U) | 
                                          (1U & (~ (IData)(vlTOPp->MESQ__DOT__STATE))))))))) {
        if (VL_UNLIKELY(Verilated::assertOn())) {
            VL_WRITEF("[%0t] %%Error: MESQ.sv:117: Assertion failed in %NMESQ: synthesis parallel_case, but multiple matches found\n",
                      64,VL_TIME_UNITED_Q(1),vlSymsp->name());
            VL_STOP_MT("MESQ.sv", 117, "");
        }
    }
    vlTOPp->__Vfunc_MESQ__DOT__POP_Q1_QUEUE__1__read 
        = vlTOPp->rd_q1;
    vlTOPp->MESQ__DOT__Q1_QUEUE_rd = vlTOPp->__Vfunc_MESQ__DOT__POP_Q1_QUEUE__1__read;
    if (vlTOPp->MESQ__DOT__STATE) {
        if (vlTOPp->MESQ__DOT__STATE) {
            ++(vlSymsp->__Vcoverage[46]);
            if (vlTOPp->MESQ__DOT__IDLE) {
                ++(vlSymsp->__Vcoverage[42]);
                vlTOPp->MESQ__DOT__NEXT_STATE = 1U;
            } else {
                ++(vlSymsp->__Vcoverage[43]);
            }
            if (vlTOPp->MESQ__DOT__WRITE_QUEUE) {
                vlTOPp->__Vtask_MESQ__DOT__PUSH_Q1_QUEUE__4__write_data 
                    = vlTOPp->opc;
                ++(vlSymsp->__Vcoverage[76]);
                ++(vlSymsp->__Vcoverage[62]);
                ++(vlSymsp->__Vcoverage[44]);
                vlTOPp->MESQ__DOT__NEXT_STATE = 0U;
                vlTOPp->MESQ__DOT__Q1_QUEUE_wr = 1U;
                vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data 
                    = vlTOPp->__Vtask_MESQ__DOT__PUSH_Q1_QUEUE__4__write_data;
                vlTOPp->MESQ__DOT__Q0_QUEUE_rd = 0U;
                vlTOPp->MESQ__DOT__Q0_QUEUE_wr = 0U;
                vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data = 0U;
            } else {
                ++(vlSymsp->__Vcoverage[45]);
            }
        }
    } else {
        ++(vlSymsp->__Vcoverage[41]);
        if (vlTOPp->MESQ__DOT__IDLE) {
            ++(vlSymsp->__Vcoverage[37]);
            vlTOPp->MESQ__DOT__NEXT_STATE = 0U;
        } else {
            ++(vlSymsp->__Vcoverage[38]);
        }
        if (vlTOPp->MESQ__DOT__WRITE_QUEUE) {
            vlTOPp->__Vtask_MESQ__DOT__PUSH_Q0_QUEUE__2__write_data 
                = vlTOPp->opc;
            ++(vlSymsp->__Vcoverage[61]);
            ++(vlSymsp->__Vcoverage[77]);
            ++(vlSymsp->__Vcoverage[39]);
            vlTOPp->MESQ__DOT__NEXT_STATE = 1U;
            vlTOPp->MESQ__DOT__Q0_QUEUE_wr = 1U;
            vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data = vlTOPp->__Vtask_MESQ__DOT__PUSH_Q0_QUEUE__2__write_data;
            vlTOPp->MESQ__DOT__Q1_QUEUE_rd = 0U;
            vlTOPp->MESQ__DOT__Q1_QUEUE_wr = 0U;
            vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data = 0U;
        } else {
            ++(vlSymsp->__Vcoverage[40]);
        }
    }
    if ((1U & ((IData)(vlTOPp->data_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q0))) {
        ++(vlSymsp->__Vcoverage[10]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q0 = ((0x1eU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q0)) 
                                                 | (1U 
                                                    & (IData)(vlTOPp->data_q0)));
    }
    if ((2U & ((IData)(vlTOPp->data_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q0))) {
        ++(vlSymsp->__Vcoverage[11]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q0 = ((0x1dU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q0)) 
                                                 | (2U 
                                                    & (IData)(vlTOPp->data_q0)));
    }
    if ((4U & ((IData)(vlTOPp->data_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q0))) {
        ++(vlSymsp->__Vcoverage[12]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q0 = ((0x1bU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q0)) 
                                                 | (4U 
                                                    & (IData)(vlTOPp->data_q0)));
    }
    if ((8U & ((IData)(vlTOPp->data_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q0))) {
        ++(vlSymsp->__Vcoverage[13]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q0 = ((0x17U 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q0)) 
                                                 | (8U 
                                                    & (IData)(vlTOPp->data_q0)));
    }
    if ((0x10U & ((IData)(vlTOPp->data_q0) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q0))) {
        ++(vlSymsp->__Vcoverage[14]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q0 = ((0xfU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q0)) 
                                                 | (0x10U 
                                                    & (IData)(vlTOPp->data_q0)));
    }
    if ((1U & ((IData)(vlTOPp->data_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q1))) {
        ++(vlSymsp->__Vcoverage[17]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q1 = ((0x1eU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q1)) 
                                                 | (1U 
                                                    & (IData)(vlTOPp->data_q1)));
    }
    if ((2U & ((IData)(vlTOPp->data_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q1))) {
        ++(vlSymsp->__Vcoverage[18]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q1 = ((0x1dU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q1)) 
                                                 | (2U 
                                                    & (IData)(vlTOPp->data_q1)));
    }
    if ((4U & ((IData)(vlTOPp->data_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q1))) {
        ++(vlSymsp->__Vcoverage[19]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q1 = ((0x1bU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q1)) 
                                                 | (4U 
                                                    & (IData)(vlTOPp->data_q1)));
    }
    if ((8U & ((IData)(vlTOPp->data_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q1))) {
        ++(vlSymsp->__Vcoverage[20]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q1 = ((0x17U 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q1)) 
                                                 | (8U 
                                                    & (IData)(vlTOPp->data_q1)));
    }
    if ((0x10U & ((IData)(vlTOPp->data_q1) ^ vlTOPp->MESQ__DOT____Vtogcov__data_q1))) {
        ++(vlSymsp->__Vcoverage[21]);
        vlTOPp->MESQ__DOT____Vtogcov__data_q1 = ((0xfU 
                                                  & (IData)(vlTOPp->MESQ__DOT____Vtogcov__data_q1)) 
                                                 | (0x10U 
                                                    & (IData)(vlTOPp->data_q1)));
    }
    if (((IData)(vlTOPp->MESQ__DOT__NEXT_STATE) ^ vlTOPp->MESQ__DOT____Vtogcov__NEXT_STATE)) {
        ++(vlSymsp->__Vcoverage[25]);
        vlTOPp->MESQ__DOT____Vtogcov__NEXT_STATE = vlTOPp->MESQ__DOT__NEXT_STATE;
    }
    if (((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr) ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr)) {
        ++(vlSymsp->__Vcoverage[70]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr = vlTOPp->MESQ__DOT__Q1_QUEUE_wr;
    }
    if (((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr) ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr)) {
        ++(vlSymsp->__Vcoverage[55]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr = vlTOPp->MESQ__DOT__Q0_QUEUE_wr;
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[71]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data 
            = ((0x1eU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[72]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data 
            = ((0x1dU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[73]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data 
            = ((0x1bU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[74]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data 
            = ((0x17U & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data)) 
               | (8U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data) 
                  ^ vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[75]);
        vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data 
            = ((0xfU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q1_QUEUE_wr_data)) 
               | (0x10U & (IData)(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data)));
    }
    if ((1U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[56]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data 
            = ((0x1eU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data)) 
               | (1U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[57]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data 
            = ((0x1dU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data)) 
               | (2U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[58]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data 
            = ((0x1bU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data)) 
               | (4U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data) 
               ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[59]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data 
            = ((0x17U & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data)) 
               | (8U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data) 
                  ^ vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data))) {
        ++(vlSymsp->__Vcoverage[60]);
        vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data 
            = ((0xfU & (IData)(vlTOPp->MESQ__DOT____Vtogcov__Q0_QUEUE_wr_data)) 
               | (0x10U & (IData)(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data)));
    }
}

void VMESQ::_eval(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_eval\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__1(vlSymsp);
    vlTOPp->__Vm_traceActivity[1U] = 1U;
    if (((IData)(vlTOPp->clk) & (~ (IData)(vlTOPp->__Vclklast__TOP__clk)))) {
        vlTOPp->_sequent__TOP__4(vlSymsp);
        vlTOPp->__Vm_traceActivity[2U] = 1U;
    }
    vlTOPp->_combo__TOP__6(vlSymsp);
    // Final
    vlTOPp->__Vclklast__TOP__clk = vlTOPp->clk;
}

VL_INLINE_OPT QData VMESQ::_change_request(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_change_request\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    return (vlTOPp->_change_request_1(vlSymsp));
}

VL_INLINE_OPT QData VMESQ::_change_request_1(VMESQ__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_change_request_1\n"); );
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    QData __req = false;  // Logically a bool
    __req |= ((vlTOPp->MESQ__DOT__Q0_QUEUE_rd ^ vlTOPp->__Vchglast__TOP__MESQ__DOT__Q0_QUEUE_rd)
         | (vlTOPp->MESQ__DOT__Q1_QUEUE_rd ^ vlTOPp->__Vchglast__TOP__MESQ__DOT__Q1_QUEUE_rd));
    VL_DEBUG_IF( if(__req && ((vlTOPp->MESQ__DOT__Q0_QUEUE_rd ^ vlTOPp->__Vchglast__TOP__MESQ__DOT__Q0_QUEUE_rd))) VL_DBG_MSGF("        CHANGE: MESQ.sv:145: MESQ.Q0_QUEUE_rd\n"); );
    VL_DEBUG_IF( if(__req && ((vlTOPp->MESQ__DOT__Q1_QUEUE_rd ^ vlTOPp->__Vchglast__TOP__MESQ__DOT__Q1_QUEUE_rd))) VL_DBG_MSGF("        CHANGE: MESQ.sv:167: MESQ.Q1_QUEUE_rd\n"); );
    // Final
    vlTOPp->__Vchglast__TOP__MESQ__DOT__Q0_QUEUE_rd 
        = vlTOPp->MESQ__DOT__Q0_QUEUE_rd;
    vlTOPp->__Vchglast__TOP__MESQ__DOT__Q1_QUEUE_rd 
        = vlTOPp->MESQ__DOT__Q1_QUEUE_rd;
    return __req;
}

#ifdef VL_DEBUG
void VMESQ::_eval_debug_assertions() {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESQ::_eval_debug_assertions\n"); );
    // Body
    if (VL_UNLIKELY((clk & 0xfeU))) {
        Verilated::overWidthError("clk");}
    if (VL_UNLIKELY((res_n & 0xfeU))) {
        Verilated::overWidthError("res_n");}
    if (VL_UNLIKELY((opc_vld & 0xfeU))) {
        Verilated::overWidthError("opc_vld");}
    if (VL_UNLIKELY((opc & 0xe0U))) {
        Verilated::overWidthError("opc");}
    if (VL_UNLIKELY((rd_q0 & 0xfeU))) {
        Verilated::overWidthError("rd_q0");}
    if (VL_UNLIKELY((rd_q1 & 0xfeU))) {
        Verilated::overWidthError("rd_q1");}
}
#endif  // VL_DEBUG
