// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VMESQ__Syms.h"


//======================

void VMESQ::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VMESQ::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VMESQ::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VMESQ::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VMESQ::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VMESQ__Syms* __restrict vlSymsp = static_cast<VMESQ__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VMESQ::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VMESQ::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VMESQ__Syms* __restrict vlSymsp = static_cast<VMESQ__Syms*>(userp);
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VMESQ::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VMESQ__Syms* __restrict vlSymsp = static_cast<VMESQ__Syms*>(userp);
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+35,"clk", false,-1);
        tracep->declBit(c+36,"res_n", false,-1);
        tracep->declBit(c+37,"opc_vld", false,-1);
        tracep->declBus(c+38,"opc", false,-1, 4,0);
        tracep->declBit(c+39,"rd_q0", false,-1);
        tracep->declBit(c+40,"rd_q1", false,-1);
        tracep->declBus(c+41,"data_q0", false,-1, 4,0);
        tracep->declBit(c+42,"empty_q0", false,-1);
        tracep->declBit(c+43,"full_q0", false,-1);
        tracep->declBus(c+44,"data_q1", false,-1, 4,0);
        tracep->declBit(c+45,"empty_q1", false,-1);
        tracep->declBit(c+46,"full_q1", false,-1);
        tracep->declBit(c+35,"MESQ clk", false,-1);
        tracep->declBit(c+36,"MESQ res_n", false,-1);
        tracep->declBit(c+37,"MESQ opc_vld", false,-1);
        tracep->declBus(c+38,"MESQ opc", false,-1, 4,0);
        tracep->declBit(c+39,"MESQ rd_q0", false,-1);
        tracep->declBit(c+40,"MESQ rd_q1", false,-1);
        tracep->declBus(c+41,"MESQ data_q0", false,-1, 4,0);
        tracep->declBit(c+42,"MESQ empty_q0", false,-1);
        tracep->declBit(c+43,"MESQ full_q0", false,-1);
        tracep->declBus(c+44,"MESQ data_q1", false,-1, 4,0);
        tracep->declBit(c+45,"MESQ empty_q1", false,-1);
        tracep->declBit(c+46,"MESQ full_q1", false,-1);
        tracep->declBus(c+47,"MESQ OPC_WIDTH", false,-1, 31,0);
        tracep->declBus(c+48,"MESQ QUEUE_SIZE", false,-1, 31,0);
        tracep->declBus(c+49,"MESQ ZERO_DATA", false,-1, 4,0);
        tracep->declBus(c+14,"MESQ STATE", false,-1, 0,0);
        tracep->declBus(c+3,"MESQ NEXT_STATE", false,-1, 0,0);
        tracep->declBit(c+4,"MESQ IDLE", false,-1);
        tracep->declBit(c+5,"MESQ WRITE_QUEUE", false,-1);
        tracep->declBit(c+6,"MESQ Q0_QUEUE_rd", false,-1);
        tracep->declBus(c+7,"MESQ Q0_QUEUE_rd_data", false,-1, 4,0);
        tracep->declBit(c+8,"MESQ Q0_QUEUE_wr", false,-1);
        tracep->declBus(c+9,"MESQ Q0_QUEUE_wr_data", false,-1, 4,0);
        tracep->declBit(c+10,"MESQ Q1_QUEUE_rd", false,-1);
        tracep->declBus(c+11,"MESQ Q1_QUEUE_rd_data", false,-1, 4,0);
        tracep->declBit(c+12,"MESQ Q1_QUEUE_wr", false,-1);
        tracep->declBus(c+13,"MESQ Q1_QUEUE_wr_data", false,-1, 4,0);
        tracep->declBus(c+50,"MESQ Q0_QUEUE DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+51,"MESQ Q0_QUEUE NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+52,"MESQ Q0_QUEUE ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+35,"MESQ Q0_QUEUE clk", false,-1);
        tracep->declBit(c+36,"MESQ Q0_QUEUE res_n", false,-1);
        tracep->declBit(c+6,"MESQ Q0_QUEUE rd", false,-1);
        tracep->declBit(c+8,"MESQ Q0_QUEUE wr", false,-1);
        tracep->declBus(c+9,"MESQ Q0_QUEUE wr_data", false,-1, 4,0);
        tracep->declBus(c+7,"MESQ Q0_QUEUE rd_data", false,-1, 4,0);
        tracep->declBit(c+42,"MESQ Q0_QUEUE empty", false,-1);
        tracep->declBit(c+43,"MESQ Q0_QUEUE full", false,-1);
        tracep->declBus(c+53,"MESQ Q0_QUEUE ZERO_ADDR", false,-1, 2,0);
        tracep->declBus(c+49,"MESQ Q0_QUEUE ZERO_DATA", false,-1, 4,0);
        {int i; for (i=0; i<8; i++) {
                tracep->declBus(c+15+i*1,"MESQ Q0_QUEUE MEMORY", true,(i+0), 4,0);}}
        tracep->declBus(c+23,"MESQ Q0_QUEUE HEAD", false,-1, 2,0);
        tracep->declBus(c+24,"MESQ Q0_QUEUE TAIL", false,-1, 2,0);
        tracep->declBus(c+1,"MESQ Q0_QUEUE i", false,-1, 31,0);
        tracep->declBus(c+50,"MESQ Q1_QUEUE DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+51,"MESQ Q1_QUEUE NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+52,"MESQ Q1_QUEUE ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+35,"MESQ Q1_QUEUE clk", false,-1);
        tracep->declBit(c+36,"MESQ Q1_QUEUE res_n", false,-1);
        tracep->declBit(c+10,"MESQ Q1_QUEUE rd", false,-1);
        tracep->declBit(c+12,"MESQ Q1_QUEUE wr", false,-1);
        tracep->declBus(c+13,"MESQ Q1_QUEUE wr_data", false,-1, 4,0);
        tracep->declBus(c+11,"MESQ Q1_QUEUE rd_data", false,-1, 4,0);
        tracep->declBit(c+45,"MESQ Q1_QUEUE empty", false,-1);
        tracep->declBit(c+46,"MESQ Q1_QUEUE full", false,-1);
        tracep->declBus(c+53,"MESQ Q1_QUEUE ZERO_ADDR", false,-1, 2,0);
        tracep->declBus(c+49,"MESQ Q1_QUEUE ZERO_DATA", false,-1, 4,0);
        {int i; for (i=0; i<8; i++) {
                tracep->declBus(c+25+i*1,"MESQ Q1_QUEUE MEMORY", true,(i+0), 4,0);}}
        tracep->declBus(c+33,"MESQ Q1_QUEUE HEAD", false,-1, 2,0);
        tracep->declBus(c+34,"MESQ Q1_QUEUE TAIL", false,-1, 2,0);
        tracep->declBus(c+2,"MESQ Q1_QUEUE i", false,-1, 31,0);
    }
}

void VMESQ::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VMESQ::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VMESQ__Syms* __restrict vlSymsp = static_cast<VMESQ__Syms*>(userp);
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VMESQ::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VMESQ__Syms* __restrict vlSymsp = static_cast<VMESQ__Syms*>(userp);
    VMESQ* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__i),32);
        tracep->fullIData(oldp+2,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__i),32);
        tracep->fullBit(oldp+3,(vlTOPp->MESQ__DOT__NEXT_STATE));
        tracep->fullBit(oldp+4,(vlTOPp->MESQ__DOT__IDLE));
        tracep->fullBit(oldp+5,(vlTOPp->MESQ__DOT__WRITE_QUEUE));
        tracep->fullBit(oldp+6,(vlTOPp->MESQ__DOT__Q0_QUEUE_rd));
        tracep->fullCData(oldp+7,(vlTOPp->MESQ__DOT__Q0_QUEUE_rd_data),5);
        tracep->fullBit(oldp+8,(vlTOPp->MESQ__DOT__Q0_QUEUE_wr));
        tracep->fullCData(oldp+9,(vlTOPp->MESQ__DOT__Q0_QUEUE_wr_data),5);
        tracep->fullBit(oldp+10,(vlTOPp->MESQ__DOT__Q1_QUEUE_rd));
        tracep->fullCData(oldp+11,(vlTOPp->MESQ__DOT__Q1_QUEUE_rd_data),5);
        tracep->fullBit(oldp+12,(vlTOPp->MESQ__DOT__Q1_QUEUE_wr));
        tracep->fullCData(oldp+13,(vlTOPp->MESQ__DOT__Q1_QUEUE_wr_data),5);
        tracep->fullBit(oldp+14,(vlTOPp->MESQ__DOT__STATE));
        tracep->fullCData(oldp+15,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[0]),5);
        tracep->fullCData(oldp+16,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[1]),5);
        tracep->fullCData(oldp+17,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[2]),5);
        tracep->fullCData(oldp+18,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[3]),5);
        tracep->fullCData(oldp+19,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[4]),5);
        tracep->fullCData(oldp+20,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[5]),5);
        tracep->fullCData(oldp+21,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[6]),5);
        tracep->fullCData(oldp+22,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__MEMORY[7]),5);
        tracep->fullCData(oldp+23,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__HEAD),3);
        tracep->fullCData(oldp+24,(vlTOPp->MESQ__DOT__Q0_QUEUE__DOT__TAIL),3);
        tracep->fullCData(oldp+25,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[0]),5);
        tracep->fullCData(oldp+26,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[1]),5);
        tracep->fullCData(oldp+27,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[2]),5);
        tracep->fullCData(oldp+28,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[3]),5);
        tracep->fullCData(oldp+29,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[4]),5);
        tracep->fullCData(oldp+30,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[5]),5);
        tracep->fullCData(oldp+31,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[6]),5);
        tracep->fullCData(oldp+32,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__MEMORY[7]),5);
        tracep->fullCData(oldp+33,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__HEAD),3);
        tracep->fullCData(oldp+34,(vlTOPp->MESQ__DOT__Q1_QUEUE__DOT__TAIL),3);
        tracep->fullBit(oldp+35,(vlTOPp->clk));
        tracep->fullBit(oldp+36,(vlTOPp->res_n));
        tracep->fullBit(oldp+37,(vlTOPp->opc_vld));
        tracep->fullCData(oldp+38,(vlTOPp->opc),5);
        tracep->fullBit(oldp+39,(vlTOPp->rd_q0));
        tracep->fullBit(oldp+40,(vlTOPp->rd_q1));
        tracep->fullCData(oldp+41,(vlTOPp->data_q0),5);
        tracep->fullBit(oldp+42,(vlTOPp->empty_q0));
        tracep->fullBit(oldp+43,(vlTOPp->full_q0));
        tracep->fullCData(oldp+44,(vlTOPp->data_q1),5);
        tracep->fullBit(oldp+45,(vlTOPp->empty_q1));
        tracep->fullBit(oldp+46,(vlTOPp->full_q1));
        tracep->fullIData(oldp+47,(5U),32);
        tracep->fullIData(oldp+48,(8U),32);
        tracep->fullCData(oldp+49,(0U),5);
        tracep->fullIData(oldp+50,(5U),32);
        tracep->fullIData(oldp+51,(8U),32);
        tracep->fullIData(oldp+52,(3U),32);
        tracep->fullCData(oldp+53,(0U),3);
    }
}
